define(['require', 'app'],
    function(require, APP) {
        /**
         * Controller for ShowMapaRutasTecnicoOrdenes generated by Appery.io
         * @module ShowMapaRutasTecnicoOrdenes
         */
        APP.controller('ShowMapaRutasTecnicoOrdenesController', ['$scope', 'Apperyio', ShowMapaRutasTecnicoOrdenesController]);

        function ShowMapaRutasTecnicoOrdenesController($scope, Apperyio) {
            // user controller variables
            $scope.posiciones = Apperyio.EntityAPI('Strings');
            // user controller functions
            /**
             * @function init
             * @param fechaAsignacion
             */
            $scope.init = function(fechaAsignacion) {
                $scope.empresa = JSON.parse(localStorage.getItem("companyData"));
                $scope.codigoUsuario = Apperyio.get('userManager').operatorId;
                $scope.nombreUsuario = Apperyio.get('userManager').operatorName;
                $scope.usernameUsuario = Apperyio.get('userManager').operatorUsername;
                $scope.stateList = Apperyio.get('userManager').stateList;
                $scope.fechaAsignacionData = fechaAsignacion ? formatDate3(fechaAsignacion.toISOString()) : formatDateNow2(0);
                $scope.posiciones = [];
                showPositionsOperator();
            };
            /**
             * @function showPositionsOperator
             */
            function showPositionsOperator() {
                var requestData = {};
                requestData = (function mapping8066($scope) {
                    var requestData = {};
                    requestData.params = {};
                    requestData.params.where = {
                        "$and": [{
                                "operatorCode": $scope.codigoUsuario
                            },
                            {
                                "companyId": $scope.empresa.idCliente
                            },
                            {
                                "documentStatus": {
                                    "$in": [2, 4, 5, 6]
                                }
                            },
                            {
                                "assignmentDate": ($scope.fechaAsignacionData ? $scope.fechaAsignacionData : "")
                            }
                        ]
                    };
                    requestData.sort = "endDate, ";
                    return requestData;
                    /*|button_mapping|onbeforesend|C52E5193-46B1-4A59-D7BE-7D666815D628||8066|*/
                })($scope);
                // read more about using rest services: https://links.appery.io/ve-snippet-rest
                Apperyio.get("Tech1_WORKORDER_query_service")(requestData).then( /*|service_bookmark|bookmark|C52E5193-46B1-4A59-D7BE-7D666815D628||1238|*/
                    function(success) { // success callback
                        (function mapping3597(success, $scope) {
                            var posiciones_scope = $scope.posiciones;
                            for (var i = 0, l = success.data.length; i < l; i++) {
                                _.set(posiciones_scope, '[' + i + '].assignmentLocation', success.data[i].assignmentLocation);
                                _.set(posiciones_scope, '[' + i + '].initLocation', success.data[i].initLocation);
                                _.set(posiciones_scope, '[' + i + '].endLocation', success.data[i].endLocation);
                                _.set(posiciones_scope, '[' + i + '].initDate', success.data[i].initDate);
                                _.set(posiciones_scope, '[' + i + '].endDate', success.data[i].endDate);
                                _.set(posiciones_scope, '[' + i + '].initOperatorId', success.data[i].initOperatorId);
                                _.set(posiciones_scope, '[' + i + '].endOperatorId', success.data[i].endOperatorId);
                                _.set(posiciones_scope, '[' + i + '].documentStatus', success.data[i].documentStatus);
                                _.set(posiciones_scope, '[' + i + '].documentCode', success.data[i].documentCode);
                                _.set(posiciones_scope, '[' + i + '].receiverAntecedent', success.data[i].receiverAntecedent);
                            }
                            $scope.posiciones = posiciones_scope;
                            /*|button_mapping|onsuccess|C52E5193-46B1-4A59-D7BE-7D666815D628||3597|*/
                        })(success, $scope);
                        $scope.markList = [];
                        var contador = 0;
                        for (var i in $scope.posiciones) {
                            if ($scope.posiciones[i].endLocation) {
                                contador++;
                                if ($scope.posiciones[i].initLocation) {
                                    $scope.posiciones[i].endLocation.initTime = $scope.posiciones[i].initLocation.time;
                                }
                                $scope.posiciones[i].endLocation.contador = contador;
                                $scope.posiciones[i].endLocation.direccion = $scope.posiciones[i].receiverAntecedent ? findValueFromKey($scope.posiciones[i].receiverAntecedent.fields, "Dirección") + ", " + findValueFromKey($scope.posiciones[i].receiverAntecedent.fields, "Comuna") : "";
                                $scope.posiciones[i].endLocation.documentCode = $scope.posiciones[i].documentCode;
                                $scope.posiciones[i].endLocation.options = $scope.stateList[$scope.posiciones[i].documentStatus].optionsLocation;
                                $scope.markList.push($scope.posiciones[i].endLocation)
                            } else if ($scope.posiciones[i].assignmentLocation) {
                                $scope.posiciones[i].assignmentLocation.contador = "--";
                                $scope.posiciones[i].assignmentLocation.direccion = $scope.posiciones[i].receiverAntecedent ? findValueFromKey($scope.posiciones[i].receiverAntecedent.fields, "Dirección") + ", " + findValueFromKey($scope.posiciones[i].receiverAntecedent.fields, "Comuna") : "";
                                $scope.posiciones[i].assignmentLocation.documentCode = $scope.posiciones[i].documentCode;
                                $scope.posiciones[i].assignmentLocation.title = "Orden Asignada"
                                $scope.posiciones[i].assignmentLocation.options = $scope.stateList[$scope.posiciones[i].documentStatus].optionsLocation;
                                $scope.markList.push($scope.posiciones[i].assignmentLocation);
                            }
                        }
                    },
                    function(error) { // callback to handle request error
                    },
                    function(notify) { // notify callback, can fire few times
                    });
            };
            /**
             * @function findValueFromKey
             * @param array
             * @param key
             */
            function findValueFromKey(array, key) {
                if (!array || !key)
                    return null;
                for (var i in array) {
                    if (array[i].key == key) {
                        return array[i].value;
                    }
                }
                return null;
            };
            /**
             * @function formatDate3
             * @param dat
             */
            function formatDate3(dat) {
                var fecha = dat.split("T");
                return fecha[0];
            };
            /**
             * @function formatDateNow2
             * @param dias
             */
            function formatDateNow2(dias) {
                var today = new Date();
                today.setDate(today.getDate() + dias);
                var dd = today.getDate();
                var mm = today.getMonth() + 1;
                var yyyy = today.getFullYear();
                return yyyy + '-' + addZero(mm) + '-' + addZero(dd);
            };
            /**
             * @function addZero
             * @param num
             */
            function addZero(num) {
                return num < 10 ? "0" + num : num;
            };
        }
    });